diff --git a/conf/type/__package_rubygem/explorer/pkg_status b/conf/type/__package_rubygem/explorer/pkg_status
new file mode 100755
index 00000000..97620892
--- /dev/null
+++ b/conf/type/__package_rubygem/explorer/pkg_status
@@ -0,0 +1,30 @@
+#!/bin/sh
+#
+# 2011 Chase Allen James (nx-cdist@nu-ex.com)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+# Retrieve the status of a rubygem
+#
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$(cat "$__object/parameter/name")"
+else
+ name="$__object_id"
+fi
+
+# Except gem failing, if package is not known / installed
+gem list -i "$name" 2>/dev/null || exit 0
diff --git a/conf/type/__package_rubygem/gencode-remote b/conf/type/__package_rubygem/gencode-remote
new file mode 100755
index 00000000..dfc08781
--- /dev/null
+++ b/conf/type/__package_rubygem/gencode-remote
@@ -0,0 +1,51 @@
+#!/bin/sh
+#
+# 2011 Chase Allen James
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Manage Rubygem packages
+#
+
+
+if [ -f "$__object/parameter/name" ]; then
+ name="$(cat "$__object/parameter/name")"
+else
+ name="$__object_id"
+fi
+
+state="$(cat "$__object/parameter/state")"
+is_installed="$(grep "true" "$__object/explorer/pkg_status" || true)"
+
+case "$state" in
+ installed)
+ # Install only if non-existent
+ if [ -z "$is_installed" ]; then
+ echo gem install \"$name\" --no-ri --no-rdoc
+ fi
+ ;;
+ removed)
+ # Remove only if existent
+ if [ -n "$is_installed" ]; then
+ echo gem uninstall \"$name\"
+ fi
+ ;;
+ *)
+ echo "Unknown state: $state" >&2
+ exit 1
+ ;;
+esac
diff --git a/conf/type/__package_rubygem/man.text b/conf/type/__package_rubygem/man.text
new file mode 100644
index 00000000..00adc8c1
--- /dev/null
+++ b/conf/type/__package_rubygem/man.text
@@ -0,0 +1,49 @@
+cdist-type__package_rubygem(7)
+=============================
+Chase Allen James >
+
+
+NAME
+----
+cdist-type__package_rubygem - Manage rubygem packages
+
+
+DESCRIPTION
+-----------
+Rubygems is the default package management system for the Ruby programming language.
+
+
+REQUIRED PARAMETERS
+-------------------
+state::
+ Either "installed" or "removed".
+
+
+OPTIONAL PARAMETERS
+-------------------
+name::
+ If supplied, use the name and not the object id as the package name.
+
+
+EXAMPLES
+--------
+
+--------------------------------------------------------------------------------
+# Ensure sinatra is installed
+__package_rubygem sinatra --state installed
+
+# Remove package
+__package_rubygem rails --state removed
+--------------------------------------------------------------------------------
+
+
+SEE ALSO
+--------
+- cdist-type(7)
+- cdist-type__package(7)
+
+
+COPYING
+-------
+Copyright \(C) 2011 Chase Allen James. Free use of this software is
+granted under the terms of the GNU General Public License version 3 (GPLv3).
diff --git a/conf/type/__package_rubygem/parameter/optional b/conf/type/__package_rubygem/parameter/optional
new file mode 100644
index 00000000..a52167d3
--- /dev/null
+++ b/conf/type/__package_rubygem/parameter/optional
@@ -0,0 +1,2 @@
+name
+version
diff --git a/conf/type/__package_rubygem/parameter/required b/conf/type/__package_rubygem/parameter/required
new file mode 100644
index 00000000..ff72b5c7
--- /dev/null
+++ b/conf/type/__package_rubygem/parameter/required
@@ -0,0 +1 @@
+state